Cache Rules - Create

Creates a cache rule for a container registry with the specified parameters.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ContainerRegistry/registries/{registryName}/cacheRules/{cacheRuleName}?api-version=2025-11-01

URI Parameters

Name In Required Type Description
cacheRuleName
path True

string

minLength: 5
maxLength: 50
pattern: ^[a-zA-Z0-9-]*$

The name of the cache rule.

registryName
path True

string

minLength: 5
maxLength: 50
pattern: ^[a-zA-Z0-9]*$

The name of the container registry.

resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Body

Name Type Description
properties.credentialSetResourceId

string

The ARM resource ID of the credential store which is associated with the cache rule.

properties.sourceRepository

string

Source repository pulled from upstream.

properties.targetRepository

string

Target repository specified in docker pull command. Eg: docker pull myregistry.azurecr.io/{targetRepository}:{tag}

Responses

Name Type Description
200 OK

CacheRule

Resource 'CacheRule' update operation succeeded

201 Created

CacheRule

Resource 'CacheRule' create operation succeeded

Headers

  • Azure-AsyncOperation: string
  • Retry-After: integer
Other Status Codes

ErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

CacheRuleCreate

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.ContainerRegistry/registries/myRegistry/cacheRules/myCacheRule?api-version=2025-11-01

{
  "properties": {
    "sourceRepository": "docker.io/library/hello-world",
    "targetRepository": "cached-docker-hub/hello-world",
    "credentialSetResourceId": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.ContainerRegistry/registries/myRegistry/credentialSets/myCredentialSet"
  }
}

Sample response

{
  "type": "Microsoft.ContainerRegistry/registries/cacheRules",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.ContainerRegistry/registries/myRegistry/cacheRules/myCacheRule",
  "name": "myCacheRule",
  "properties": {
    "credentialSetResourceId": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.ContainerRegistry/registries/myRegistry/credentialSets/myCredentialSet",
    "sourceRepository": "docker.io/library/hello-world",
    "targetRepository": "cached-docker-hub/hello-world",
    "creationDate": "2022-11-07T18:20:33.8374968+00:00",
    "provisioningState": "Succeeded"
  }
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.ContainerRegistry/registries/myRegistry/cacheRules/myCacheRule/operationStatuses/cacherules-00000000-0000-0000-0000-000000000000?api-version=2025-11-01
{
  "type": "Microsoft.ContainerRegistry/registries/cacheRules",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.ContainerRegistry/registries/myRegistry/cacheRules/myCacheRule",
  "name": "myCacheRule",
  "properties": {
    "credentialSetResourceId": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.ContainerRegistry/registries/myRegistry/credentialSets/myCredentialSet",
    "sourceRepository": "docker.io/library/hello-world",
    "targetRepository": "cached-docker-hub/hello-world",
    "creationDate": "2022-11-07T18:20:33.8374968+00:00",
    "provisioningState": "Creating"
  }
}

Definitions

Name Description
CacheRule

An object that represents a cache rule for a container registry.

createdByType

The type of identity that created the resource.

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

ProvisioningState

The provisioning state of the archive at the time the operation was called.

systemData

Metadata pertaining to creation and last modification of the resource.

CacheRule

An object that represents a cache rule for a container registry.

Name Type Description
id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

name

string

The name of the resource

properties.creationDate

string (date-time)

The creation date of the cache rule.

properties.credentialSetResourceId

string

The ARM resource ID of the credential store which is associated with the cache rule.

properties.provisioningState

ProvisioningState

Provisioning state of the resource.

properties.sourceRepository

string

Source repository pulled from upstream.

properties.targetRepository

string

Target repository specified in docker pull command. Eg: docker pull myregistry.azurecr.io/{targetRepository}:{tag}

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

ProvisioningState

The provisioning state of the archive at the time the operation was called.

Value Description
Creating
Updating
Deleting
Succeeded
Failed
Canceled

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.